// ================================================\\
// |     : Davert       davert@ukr.net        |\\
// |      |\\
// ================================================ \\
unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, StdCtrls, Spin, ExtDlgs, ComCtrls, math;

type
  TForm1 = class(TForm)
    Image1: TImage;
    SpinEdit1: TSpinEdit;
    SpinEdit2: TSpinEdit;
    Button1: TButton;
    Bevel1: TBevel;
    RadioButton1: TRadioButton;
    RadioButton2: TRadioButton;
    Bevel2: TBevel;
    Label1: TLabel;
    Label2: TLabel;
    Button2: TButton;
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    Image2: TImage;
    OpenPictureDialog1: TOpenPictureDialog;
    Button3: TButton;
    Image3: TImage;
    Label3: TLabel;
    procedure Button1Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
  private
    Levels : array of TBitmap; // ̳- 
     imWidth:integer; //   
     imHeight:integer; //   
  public
    { Public declarations }
  end;
var
  Form1: TForm1;
implementation

{$R *.dfm}

procedure TForm1.Button1Click(Sender: TObject);
var     i,j,l:integer;
        c1,c2,c3,c4 : TColor;
        R1,G1,B1:Byte;
        R2,G2,B2:Byte;
        R,G,B:Byte;
        pHeight : integer;
        pWidth : integer;
        Pic,Pic2 : TBitmap;
begin
        PatBlt(Image2.Canvas.Handle, 0, 0, Image2.Width, Image2.Height, WHITENESS);
        imWidth:=SpinEdit1.Value;
        imHeight:=SpinEdit2.Value;
        If (Levels=nil) or ((SpinEdit1.Value>=Image1.Picture.Width) or (SpinEdit2.Value>=IMage1.Picture.Height)) then
        begin
        //  
        //   -
        pWidth:=Image1.Picture.Width;
        pHeight:=Image1.Picture.Height;
        Pic:=Image1.Picture.Bitmap;
        end
        else
        begin //  -
        l:=Length(Levels)-trunc(min(log2(SpinEdit1.Value),log2(SpinEdit2.Value)));
        If (RadioButton2.Checked) then //  
        begin
        Pic:=TBitmap.Create;
        Pic.Height:=imHeight;
        Pic.Width:=imWidth;
        pWidth:=Levels[l].Width;
        pHeight:=Levels[l].Height;
        with Levels[l].Canvas do // Գ  
        for j:=1 to imHeight do
        for i:=1 to imWidth do
        begin
        c1:=Pixels[i*pWidth div imWidth,j*pHeight div imHeight];
        c2:=Pixels[i*pWidth div imWidth+1,j*pHeight div imHeight];
        c3:=Pixels[i*pWidth div imWidth,j*pHeight div imHeight+1];
        c4:=Pixels[i*pWidth div imWidth+1,j*pHeight div imHeight+1];
        //-
        R1:=trunc(GetRValue(c1)+(GetRValue(c3)-GetRValue(c1))*frac(i*pHeight/imHeight));
        G1:=trunc(GetGValue(c1)+(GetGValue(c3)-GetGValue(c1))*frac(i*pHeight/imHeight));
        B1:=trunc(GetBValue(c1)+(GetBValue(c3)-GetBValue(c1))*frac(i*pHeight/imHeight));
        //-
        R2:=trunc(GetRValue(c2)+(GetRValue(c4)-GetRValue(c2))*frac(i*pHeight/imHeight));
        G2:=trunc(GetGValue(c2)+(GetGValue(c4)-GetGValue(c2))*frac(i*pHeight/imHeight));
        B2:=trunc(GetBValue(c2)+(GetBValue(c4)-GetBValue(c2))*frac(i*pHeight/imHeight));
        //-
        R:=trunc(R1+(R2-R1)*frac(i*pWidth/imWidth));
        G:=trunc(G1+(G2-G1)*frac(i*pWidth/imWidth));
        B:=trunc(B1+(B2-B1)*frac(i*pWidth/imWidth));

        Pic.Canvas.Pixels[i,j]:=RGB(R,G,B);
        end;

        Pic2:=TBitmap.Create;
        Pic2.Width:=imWidth;
        Pic2.Height:=imHeight;
        pWidth:=Levels[l-1].Width;
        pHeight:=Levels[l-1].Height;
        Pic2.Canvas.StretchDraw(rect(0,0,imWidth,imHeight),Levels[l-1]);
        for j:=1 to imHeight do         //    
        for i:=1 to imWidth do
        begin
        c1:=Pic.Canvas.Pixels[i,j];
        c2:=Pic2.Canvas.Pixels[i,j];

        R:=trunc(GetRValue(c1)+(GetRValue(c2)-GetRValue(c1))*(min(imWidth-Levels[l].Width,imHeight-Levels[l].Height))/min(Levels[l].Width,Levels[l].Height));
        G:=trunc(GetGValue(c1)+(GetGValue(c2)-GetGValue(c1))*(min(imWidth-Levels[l].Width,imHeight-Levels[l].Height))/min(Levels[l].Width,Levels[l].Height));
        B:=trunc(GetBValue(c1)+(GetBValue(c2)-GetBValue(c1))*(min(imWidth-Levels[l].Width,imHeight-Levels[l].Height))/min(Levels[l].Width,Levels[l].Height));

        Image2.Canvas.Pixels[i,j]:=RGB(R,G,B);
        end;
        exit;
        end
        else
        begin
        Pic:=Levels[l];
        pWidth:=Pic.Width;
        pHeight:=Pic.Height;
        end;
        end;
        PageControl1.ActivePageIndex:=0;
        with pic.Canvas do    //   
        for j:=1 to imHeight do
        for i:=1 to imWidth do
        begin
        c1:=Pixels[i*pWidth div imWidth,j*pHeight div imHeight];
        c2:=Pixels[i*pWidth div imWidth+1,j*pHeight div imHeight];
        c3:=Pixels[i*pWidth div imWidth,j*pHeight div imHeight+1];
        c4:=Pixels[i*pWidth div imWidth+1,j*pHeight div imHeight+1];
        //-
        R1:=trunc(GetRValue(c1)+(GetRValue(c3)-GetRValue(c1))*frac(j*pHeight/imHeight));
        G1:=trunc(GetGValue(c1)+(GetGValue(c3)-GetGValue(c1))*frac(j*pHeight/imHeight));
        B1:=trunc(GetBValue(c1)+(GetBValue(c3)-GetBValue(c1))*frac(j*pHeight/imHeight));
        //-
        R2:=trunc(GetRValue(c2)+(GetRValue(c4)-GetRValue(c2))*frac(j*pHeight/imHeight));
        G2:=trunc(GetGValue(c2)+(GetGValue(c4)-GetGValue(c2))*frac(j*pHeight/imHeight));
        B2:=trunc(GetBValue(c2)+(GetBValue(c4)-GetBValue(c2))*frac(j*pHeight/imHeight));
        //-
        R:=trunc(R1+(R2-R1)*frac(i*pWidth/imWidth));
        G:=trunc(G1+(G2-G1)*frac(i*pWidth/imWidth));
        B:=trunc(B1+(B2-B1)*frac(i*pWidth/imWidth));

        Image2.Canvas.Pixels[i,j]:=RGB(R,G,B);
        end;
        Button2Click(nil);
        end;

procedure TForm1.Button3Click(Sender: TObject);
begin
        If OpenPictureDialog1.Execute then
        Image1.Picture.LoadFromFile(OpenPictureDialog1.FileName);
        If (frac(log2(Image1.Picture.Width))>0) or (frac(log2(Image1.Picture.Height))>0) then
        ShowMessage('     '+#13+'    -   ');
        SpinEdit1.MinValue:=Image1.Picture.Width;
        SpinEdit2.MinValue:=Image1.Picture.Height;
        SpinEdit1.Value:=Image1.Picture.Width;
        SpinEdit2.Value:=Image1.Picture.Height;
        Levels:=nil;
end;

procedure TForm1.Button2Click(Sender: TObject);
var i,u,v,pos:integer;
    c1,c2,c3,c4: TColor;
    R,G,B:Byte;
    LevelsCount : byte;
begin
        If (frac(log2(Image1.Picture.Width))<>0) or (frac(log2(Image1.Picture.Height))<>0) then exit;
        LevelsCount:=trunc(log2(min(Image1.Picture.Width,Image1.Picture.Height)));
        SetLength(Levels,LevelsCount);
        for i:=0 to LevelsCount-1 do Levels[i]:=TBitmap.Create;
        Levels[0]:=Image1.Picture.Bitmap;
        Image3.Canvas.Draw(0,0,Levels[0]);
        pos:=Levels[0].Height+1;
        for i:= 1 to LevelsCount-1 do
        begin
        Levels[i].Width:=Levels[i-1].Width div 2;
        Levels[i].Height:=Levels[i-1].Height div 2;
        for v:=0 to Levels[i-1].Height div 2 do        
        for u:=0 to Levels[i-1].Width div 2 do
        begin
        c1:=Levels[i-1].Canvas.Pixels[2*u,2*v];
        c2:=Levels[i-1].Canvas.Pixels[2*u+1,2*v];
        c3:=Levels[i-1].Canvas.Pixels[2*u,2*v+1];
        c4:=Levels[i-1].Canvas.Pixels[2*u+1,2*v+1];
        R:=(GetRValue(c1)+GetRValue(c2)+GetRValue(c3)+GetRValue(c4)) div 4;
        G:=(GetGValue(c1)+GetGValue(c2)+GetGValue(c3)+GetGValue(c4)) div 4;
        B:=(GetBValue(c1)+GetBValue(c2)+GetBValue(c3)+GetBValue(c4)) div 4;
        Levels[i].Canvas.Pixels[u,v]:=RGB(R,G,B);
        end;
        Image3.Canvas.Draw(0,pos,Levels[i]);
        pos:=pos+Levels[i].Height+1;
        end;
        SPinEdit1.MinValue:=1;
        SpinEdit2.MinValue:=1;
end;

end.
